#include "common.h"

/* Definitions */

//#define DEBUG

/* global varables */

typedef unsigned char               ip[16];  // ip address
typedef unsigned char               dn[64];  // domain name

/* General usage globals */

I  fh1;
L  DNSloc=0, count=0;
I  oldhour=-1;

#define DNSLIST                 "./"

/* General usage globals */

I  INDNSList(C *sp);

S
  {
    ip ip;
    dn resolved;
  } DNSList;

/* Prototypes */

C *Resolver(C *d, C *sp);
V  AddAddress(C *sp);

/* Include code commons */

I main(I argc, C *argv[])
  {
    FILE   *fd;
    STR     d1;
        
    AddAddress(argv[1]);
    return(0);
  }

V AddAddress(C *sp)
  {
    dn d1, d2, d3;
    I  i, j, done=FALSE;

    done=INDNSList(sp);

    if(done==FALSE)
      {
        dstrcopy(DNSList.ip,sp);
        DNSList.resolved[0]='\0';
    
        Resolver(DNSList.resolved,DNSList.ip);
        if(DNSList.resolved[0]!='\0') // Only add if resolvable
          {
            dstrcopy(d1,sp);
            
            for(i=dstrlen(d1);d1[i]!='.';i--);
            d1[i]='\0';
            for(i=0;d1[i]!='\0';i++)
              if(d1[i]=='.')
                d1[i]='/';
            
            //   /usr/sbin/dns/207
            
            for(i=0;d1[i]!='/';i++)
              d2[i]=d1[i];
            d2[i]='\0';  
            sprintf(d3,"%s%s",DNSLIST,d2);
            if(exist(d3)==FALSE)
              mkdir(d3,S_IREAD|S_IWRITE|S_IEXEC);

            //   /usr/sbin/207/232
            
            for(j=i+1;d1[j]!='/';j++);
            for(i=0;i<j;i++)
              d2[i]=d1[i];
            d2[i]='\0';  
            sprintf(d3,"%s%s",DNSLIST,d2);
            if(exist(d3)==FALSE)
              mkdir(d3,S_IREAD|S_IWRITE|S_IEXEC);

            // Make DNS extry

            sprintf(d2,"%s%s",DNSLIST,d1);      
            fh1=sopen(d2,O_RDWR|O_CREAT,SH_DENYNO,S_IREAD|S_IWRITE);
            lseek(fh1,0,SEEK_END);
            write(fh1,&DNSList,sizeof(DNSList));
            close(fh1);
          }
      }
  }

C *Resolver(C *d, C *sp)
  {
    S   hostent *hent;
    I   addr;
    C   ia[4];

    dupstr(d,'\0',sizeof(dn));
    
    addr=inet_addr(sp);
    ia[3] = addr >> 24 & 255;
    ia[2] = addr >> 16 & 255;
    ia[1] = addr >>  8 & 255;
    ia[0] = addr       & 255;
    hent = gethostbyaddr (ia, 4, AF_INET);
    if(hent && hent->h_name && *hent->h_name)
      dstrcopy(d,hent->h_name);
    else
      d[0]='\0';
      
    return(d);
  }

I INDNSList(C *sp)
  {
    dn d1, d2;
    I  fh1, i, lr, done=FALSE;

    dstrcopy(d1,sp);
    for(i=dstrlen(d1);d1[i]!='.';i--);
    d1[i]='\0';
    
    for(i=0;d1[i]!='\0';i++)   // Make into directories
      if(d1[i]=='.')
        d1[i]='/';

    sprintf(d2,"%s%s",DNSLIST,d1);

    fh1=sopen(d2,O_RDONLY,SH_DENYNO,S_IREAD);
    if(fh1>0)
      {
        lr=lseek(fh1,0,SEEK_END)/sizeof(DNSList);
        for(i=0;i<lr && done==FALSE;i++)
          {
            lseek(fh1,i*sizeof(DNSList),SEEK_SET);
            read(fh1,&DNSList,sizeof(DNSList));
    
            done=dstrcmp(sp,DNSList.ip);
          }
        close(fh1);
      }
    return(done);
  }

#include "common.c"

